## skiboot 5.0.4

=== external/gard/Makefile ===
# This tool is a linux userland tool and should be completely stand alone

CC = $(CROSS_COMPILE)gcc
CFLAGS = -m64 -Werror -Wall -g2 -ggdb
LDFLAGS = -m64
ASFLAGS = -m64
CPPFLAGS = -I. -I../../

OBJS = file_flash.o gard.o libflash.o libffs.o ecc.o

EXE = gard

all: $(EXE)

%.o: %.c
	$(COMPILE.c) $< -o $@

%.o: ../../libflash/%.c
	$(COMPILE.c) $< -o $@

$(EXE): $(OBJS)
	$(LINK.o) -o $@ $^

clean:
	rm -f $(OBJS) $(EXE) *.d

=== external/opal-prd/Makefile ===
CC = $(CROSS_COMPILE)gcc

CFLAGS = -m64 -Werror -Wall -g2 -ggdb
LDFLAGS = -m64
ASFLAGS = -m64
CPPFLAGS = -I. -I../../include -I../../

prefix = /usr/local/
sbindir = $(prefix)/sbin

# Use make V=1 for a verbose build.
ifndef V
        Q_CC=	@echo '    CC ' $@;
        Q_LINK=	@echo '  LINK ' $@;
        Q_LN=   @echo '    LN ' $@;
        Q_MKDIR=@echo ' MKDIR ' $@;
endif

OBJS = opal-prd.o thunk.o pnor.o i2c.o module.o libffs.o libflash.o ecc.o

all: opal-prd

LINKS = ccan

ifdef KERNEL_DIR
LINKS += asm/opal-prd.h
endif

ccan:
	$(Q_LN)ln -sfr ../../ccan ./ccan

asm/opal-prd.h:
	$(Q_MKDIR)mkdir -p asm
	$(Q_LN)ln -sfr $(KERNEL_DIR)/arch/powerpc/include/uapi/asm/opal-prd.h \
			asm/opal-prd.h

$(OBJS): $(LINKS)

%.o: %.c
	$(Q_CC)$(COMPILE.c) $< -o $@

%.o: ../../libflash/%.c
	$(Q_CC)$(COMPILE.c) $< -o $@

%.o: %.S
	$(Q_CC)$(COMPILE.S) $< -o $@

opal-prd: $(OBJS)
	$(Q_LINK)$(LINK.o) -o $@ $^

test: test/test_pnor

test/test_pnor: test/test_pnor.o pnor.o libflash/libflash.o libflash/libffs.o
	$(Q_LINK)$(LINK.o) -o $@ $^

install: all
	install -D opal-prd $(DESTDIR)$(sbindir)/opal-prd

clean:
	$(RM) *.[odsa] opal-prd
	$(RM) test/*.[odsa] test/test_pnor

distclean: clean
	$(RM) -f $(LINKS) asm

=== external/pflash/Makefile ===
ARCH=$(shell ./get_arch.sh $(CROSS_COMPILE))

ifeq ($(ARCH),ARCH_POWERPC)
	ARCH_OBJS = powerpc_io.o sfc-ctrl.o
else
ifeq ($(ARCH),ARCH_ARM)
	ARCH_OBJS = arm_io.o
else
error_arch:
	$(error Unsupported architecture $(ARCH))
endif
endif

CFLAGS  = -O2 -Wall -I.
LDFLAGS	= -lrt
OBJS    = pflash.o progress.o ast-sf-ctrl.o
OBJS	+= libflash/libflash.o libflash/libffs.o libflash/ecc.o
OBJS	+= $(ARCH_OBJS)
EXE     = pflash

CC	= $(CROSS_COMPILE)gcc

%.o : %.c
	$(CC) $(CFLAGS) -c $< -o $@

all: $(EXE)

.PHONY: links
links:
	ln -sf ../../libflash .
	ln -sf ../../ccan .
	ln -sf ../../hw/sfc-ctrl.c .
	ln -sf ../../hw/ast-bmc/ast-sf-ctrl.c

$(OBJS) : links

$(EXE): $(OBJS)
	$(CC) $(CFLAGS) $(LDFLAGS) $^ -o $@

clean:
	rm -f $(OBJS) $(EXE) *.o *.d libflash/test/test_flash libflash/test/*.o
distclean: clean
	rm -f *.c~ *.h~ *.sh~ Makefile~ config.mk~ libflash/*.c~ libflash/*.h~
	rm -f libflash ccan sfc-ctrl.c ast-sf-ctrl.c

=== debian/changelog ===
skiboot (5.0.4-0ubuntu2) wily; urgency=medium

  * debian/patches/bundle_opal-prd.patch: Bundle a copy of opal-prd.h to make
    building easier.
  * debian/control: drop Build-Depends on linux-headers; not necessary with
    opal-prd.h bundled.

 -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Thu, 30 Jul 2015 15:21:04 -0400

skiboot (5.0.4-0ubuntu1) wily; urgency=medium

  * Initial release (LP: #1467542)

 -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Thu, 02 Jul 2015 15:00:43 -0400

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

%:
	dh $@ --with systemd

override_dh_auto_build:
	make -C external/opal-prd/
	make -C external/gard/

override_dh_auto_install:
	make -C external/opal-prd/ prefix=/usr DESTDIR=../../debian/tmp/ install
	make -C external/gard/ prefix=/usr DESTDIR=../../debian/tmp/ install

override_dh_auto_clean:
	make -C external/opal-prd/ clean
	make -C external/gard/ clean
	rm -f external/opal-prd/ccan
	dh_auto_clean

## skiboot 5.1.1

=== external/pflash/Makefile ===
include rules.mk

all: $(EXE)

.PHONY: links
links: libflash ccan sfc-ctrl.c ast-sf-ctrl.c make_version.sh

libflash:
	ln -sf ../../libflash .

ccan:
	ln -sf ../../ccan .

sfc-ctrl.c:
	ln -sf ../../hw/sfc-ctrl.c .

ast-sf-ctrl.c:
	ln -sf ../../hw/ast-bmc/ast-sf-ctrl.c

make_version.sh:
	ln -sf ../../make_version.sh

$(OBJS) : links

.PHONY: VERSION-always
.version: VERSION-always
	@echo $(PFLASH_VERSION) > $@.tmp
	@cmp -s $@ $@.tmp || cp $@.tmp $@
	@rm -f $@.tmp

.PHONY: dist
#File is named $(PFLASH_VERSION).tar because the expectation is that pflash-
#is always at the start of the verion. This remains consistent with skiboot
#version strings
dist: links .version
	find -L ../pflash/ -iname '*.[ch]' -print0 | xargs -0 tar -rhf $(PFLASH_VERSION).tar
	tar --transform 's/Makefile.dist/Makefile/' -rhf $(PFLASH_VERSION).tar \
		../pflash/get_arch.sh ../pflash/Makefile.dist ../pflash/rules.mk \
		../pflash/.version ../pflash/make_version.sh

clean:
	rm -f $(OBJS) $(EXE) *.o *.d libflash/test/test_flash libflash/test/*.o
distclean: clean
	rm -f *.c~ *.h~ *.sh~ Makefile~ config.mk~ libflash/*.c~ libflash/*.h~
	rm -f libflash ccan sfc-ctrl.c ast-sf-ctrl.c .version .version.tmp

=== debian/changelog ===
skiboot (5.1.1-0ubuntu1~15.04.1) vivid; urgency=medium

  * New upstream release. (LP: #1467542)
  * Dropped patches; applied upstream:
    - 0001-external-gard-add-Makefile-targets-to-make-debian-pa.patch
    - 0001-Honor-compilation-flags-passed-from-the-environment.patch
    - 0001-Fixes-for-compilation-with-Werror.patch
  * debian/patches/uninitialized_uses.patch: fix up uninitialized variables
    that make our build fail.

 -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Tue, 01 Sep 2015 12:37:57 -0400

## skiboot 5.1.13

=== Makefile ===
# If you want to build in another directory copy this file there and
# fill in the following values

#
# Prefix of cross toolchain, if anything
# Example: CROSS= powerpc64-unknown-linux-gnu-
#
ARCH = $(shell uname -m)
ifdef CROSS_COMPILE
	CROSS ?= $(CROSS_COMPILE)
endif
ifeq ("$(ARCH)", "ppc64")
	CROSS ?=
else
	CROSS ?= powerpc64-linux-
endif

#
# Set to enable SLW bits
#
PORE ?= 1

#
# Optional location of embedded linux kernel file
# This can be a raw vmlinux, stripped vmlinux or
# zImage.epapr
#
KERNEL ?=

#
# Optional build with advanced stack checking
#
STACK_CHECK ?= 0

#
# Where is the source directory, must be a full path (no ~)
# Example: SRC= /home/me/skiboot
#
SRC=$(CURDIR)

#
# Where to get information about this machine (subdir name)
#
DEVSRC=hdata

#
# default config file, see include config_*.h for more specifics
#
CONFIG := config.h

include $(SRC)/Makefile.main

=== external/gard/Makefile ===
# This tool is a linux userland tool and should be completely stand alone

prefix = /usr/local/
sbindir = $(prefix)/sbin
datadir = $(prefix)/share
mandir = $(datadir)/man

CC = $(CROSS_COMPILE)gcc
CFLAGS += -m64 -Werror -Wall -g2 -ggdb
LDFLAGS += -m64
ASFLAGS = -m64
CPPFLAGS += -I. -I../../

OBJS = file.o gard.o libflash.o libffs.o ecc.o blocklevel.o

EXE = gard

all: $(EXE)

%.o: %.c
	$(COMPILE.c) $< -o $@

%.o: ../../libflash/%.c
	$(COMPILE.c) $< -o $@

$(EXE): $(OBJS)
	$(LINK.o) -o $@ $^

install: all
	install -D gard $(DESTDIR)$(sbindir)/opal-gard
	install -D -m 0644 opal-gard.1 $(DESTDIR)$(mandir)/man1/opal-gard.1

clean:
	rm -f $(OBJS) $(EXE) *.d

distclean: clean

=== external/opal-prd/Makefile ===
--- 
+++ 
@@ -1,12 +1,14 @@
 CC = $(CROSS_COMPILE)gcc
 
-CFLAGS = -m64 -Werror -Wall -g2 -ggdb
-LDFLAGS = -m64
+CFLAGS += -m64 -Werror -Wall -g2 -ggdb
+LDFLAGS += -m64
 ASFLAGS = -m64
-CPPFLAGS = -I. -I../../include -I../../
+CPPFLAGS += -I. -I../../include -I../../
 
 prefix = /usr/local/
 sbindir = $(prefix)/sbin
+datadir = $(prefix)/share
+mandir = $(datadir)/man
 
 # Use make V=1 for a verbose build.
 ifndef V
@@ -16,11 +18,14 @@
         Q_MKDIR=@echo ' MKDIR ' $@;
 endif
 
-OBJS = opal-prd.o thunk.o pnor.o i2c.o module.o libffs.o libflash.o ecc.o
+OBJS = opal-prd.o thunk.o pnor.o i2c.o module.o version.o \
+       blocklevel.o libffs.o libflash.o ecc.o
 
 all: opal-prd
 
 LINKS = ccan
+
+OPAL_PRD_VERSION ?= $(shell ../../make_version.sh opal-prd)
 
 ifdef KERNEL_DIR
 LINKS += asm/opal-prd.h
@@ -48,6 +53,19 @@
 opal-prd: $(OBJS)
 	$(Q_LINK)$(LINK.o) -o $@ $^
 
+version.c: ../../make_version.sh .version
+	@(if [ "a$(OPAL_PRD_VERSION)" = "a" ]; then \
+	echo "#error You need to set OPAL_PRD_VERSION environment variable" > $@ ;\
+	else \
+	echo "const char version[] = \"$(OPAL_PRD_VERSION)\";" ;\
+	fi) > $@
+
+.PHONY: VERSION-always
+.version: VERSION-always
+	@echo $(OPAL_PRD_VERSION) > $@.tmp
+	@cmp -s $@ $@.tmp || cp $@.tmp $@
+	@rm -f $@.tmp
+
 test: test/test_pnor
 
 test/test_pnor: test/test_pnor.o pnor.o libflash/libflash.o libflash/libffs.o
@@ -55,6 +73,7 @@
 
 install: all
 	install -D opal-prd $(DESTDIR)$(sbindir)/opal-prd
+	install -D -m 0644 opal-prd.8 $(DESTDIR)$(mandir)/man8/opal-prd.8
 
 clean:
 	$(RM) *.[odsa] opal-prd

=== external/pflash/Makefile ===
include rules.mk
GET_ARCH = ../../external/common/get_arch.sh
include ../../external/common/rules.mk

all: $(EXE)

.PHONY: links
links: libflash ccan common make_version.sh

libflash:
	ln -sf ../../libflash .

ccan:
	ln -sf ../../ccan .

common:
	ln -sf ../common .

make_version.sh:
	ln -sf ../../make_version.sh

$(OBJS): | links arch_links

.PHONY: VERSION-always
.version: VERSION-always
	@echo $(PFLASH_VERSION) > $@.tmp
	@cmp -s $@ $@.tmp || cp $@.tmp $@
	@rm -f $@.tmp

.PHONY: dist
#File is named $(PFLASH_VERSION).tar because the expectation is that pflash-
#is always at the start of the verion. This remains consistent with skiboot
#version strings
dist: links .version
	find -L ../pflash/ -iname '*.[ch]' -print0 | xargs -0 tar -rhf $(PFLASH_VERSION).tar
	tar --transform 's/Makefile.dist/Makefile/' -rhf $(PFLASH_VERSION).tar \
		../pflash/Makefile.dist ../pflash/rules.mk \
		../pflash/.version ../pflash/make_version.sh \
		../pflash/common/*

clean: arch_clean
	rm -f $(OBJS) $(EXE) *.o *.d libflash/test/test_flash libflash/test/*.o
distclean: clean
	rm -f *.c~ *.h~ *.sh~ Makefile~ config.mk~ libflash/*.c~ libflash/*.h~
	rm -f libflash ccan .version .version.tmp
	rm -f common io.h make_version.sh

=== external/xscom-utils/Makefile ===
all: getscom putscom

VERSION=0.1
CFLAGS=-O2 -g -Wall -m64 -DVERSION=$(VERSION)

getscom: getscom.c xscom.c
	$(CC) $(CFLAGS) -o $@ $^

putscom: putscom.c xscom.c
	$(CC) $(CFLAGS) -o $@ $^

.PHONY: clean
clean:
	rm -rf getscom putscom

.PHONY: distclean
distclean: clean
	rm -rf *.c~ *.h~ *.i *.s Makefile~

=== debian/changelog ===
skiboot (5.1.13-0ubuntu1~14.04.1) trusty; urgency=medium

  * New upstream release, adding support for newer hardware and firmware.
    LP: #1512188.
    - drop no longer needed parts of debian/patches/uninitialized_uses.patch.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 04 Feb 2016 11:05:13 -0800

skiboot (5.1.1-0ubuntu1~14.04.1) trusty; urgency=medium

  * New upstream release.
  * Dropped patches; applied upstream:
    - 0001-external-gard-add-Makefile-targets-to-make-debian-pa.patch
    - 0001-Honor-compilation-flags-passed-from-the-environment.patch
    - 0001-Fixes-for-compilation-with-Werror.patch
  * debian/patches/uninitialized_uses.patch: fix up uninitialized variables
    that make our build fail.

 -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Tue, 01 Sep 2015 12:36:25 -0400

=== debian/control ===
Source: skiboot
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Jeremy Kerr <jk@ozlabs.org>
Build-Depends: debhelper (>= 9), dh-systemd
Standards-Version: 3.9.5
Homepage: http://github.com/open-power/skiboot/
#Vcs-Git: git://git.debian.org/collab-maint/skiboot.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/skiboot.git;a=summary

Package: opal-prd
Architecture: ppc64el
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: OPAL Processor Recovery Diagnostics daemon
 This package provides a daemon to load and run the OpenPower firmware's
 Processor Recovery Diagnostics binary. This is responsible for runtime
 maintenance of Power hardware.

Package: opal-utils
Architecture: ppc64el
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: OPAL firmware utilities
 This package contains utility programs.
 .
 The 'gard' utility, can read, parse and clear hardware gard partitions on
 OpenPower platforms.

=== debian/watch ===
version=3
https://github.com/open-power/skiboot/tags .*/skiboot-(\d\S*)\.tar\.gz

## skiboot 5.2.2

=== external/opal-prd/Makefile ===
--- 
+++ 
@@ -1,5 +1,3 @@
-CC = $(CROSS_COMPILE)gcc
-
 CFLAGS += -m64 -Werror -Wall -g2 -ggdb
 LDFLAGS += -m64
 ASFLAGS = -m64
@@ -10,6 +8,11 @@
 datadir = $(prefix)/share
 mandir = $(datadir)/man
 
+all: opal-prd
+
+GET_ARCH = ../../external/common/get_arch.sh
+include ../../external/common/rules.mk
+
 # Use make V=1 for a verbose build.
 ifndef V
         Q_CC=	@echo '    CC ' $@;
@@ -18,12 +21,14 @@
         Q_MKDIR=@echo ' MKDIR ' $@;
 endif
 
+LIBFLASH_OBJS = libflash-blocklevel.o libflash-libffs.o \
+                libflash-libflash.o libflash-ecc.o \
+                libflash-file.o
+
 OBJS = opal-prd.o thunk.o pnor.o i2c.o module.o version.o \
-       blocklevel.o libffs.o libflash.o ecc.o
+       $(LIBFLASH_OBJS) common-arch_flash.o
 
-all: opal-prd
-
-LINKS = ccan
+LINKS = ccan common libflash $(ARCH_LINKS)
 
 OPAL_PRD_VERSION ?= $(shell ../../make_version.sh opal-prd)
 
@@ -34,17 +39,23 @@
 ccan:
 	$(Q_LN)ln -sfr ../../ccan ./ccan
 
+libflash:
+	$(Q_LN)ln -sfr ../../libflash ./libflash
+
+common:
+	$(Q_LN)ln -sfr ../common ./common
+
 asm/opal-prd.h:
 	$(Q_MKDIR)mkdir -p asm
 	$(Q_LN)ln -sfr $(KERNEL_DIR)/arch/powerpc/include/uapi/asm/opal-prd.h \
 			asm/opal-prd.h
 
-$(OBJS): $(LINKS)
+$(OBJS): | $(LINKS)
 
 %.o: %.c
 	$(Q_CC)$(COMPILE.c) $< -o $@
 
-%.o: ../../libflash/%.c
+$(LIBFLASH_OBJS): libflash-%.o : libflash/%.c
 	$(Q_CC)$(COMPILE.c) $< -o $@
 
 %.o: %.S
@@ -66,9 +77,9 @@
 	@cmp -s $@ $@.tmp || cp $@.tmp $@
 	@rm -f $@.tmp
 
-test: test/test_pnor
+test: $(LINKS) test/test_pnor
 
-test/test_pnor: test/test_pnor.o pnor.o libflash/libflash.o libflash/libffs.o
+test/test_pnor: test/test_pnor.o pnor.o $(LIBFLASH_OBJS) common-arch_flash.o
 	$(Q_LINK)$(LINK.o) -o $@ $^
 
 install: all

=== external/shared/Makefile ===
.DEFAULT_GOAL := all
GET_ARCH = ../../external/common/get_arch.sh
include ../../external/common/rules.mk

PREFIX ?= /usr/local/
LIBDIR = $(PREFIX)/lib
INCDIR = $(PREFIX)/include/libflash

VERSION = $(shell ../../make_version.sh)

CFLAGS += -m64 -Werror -Wall -g2 -ggdb -I. -fPIC

.PHONY: links
links: libflash ccan common

libflash:
	ln -sf ../../libflash .

common:
	ln -sf ../common .

ccan:
	ln -sf ../../ccan .

LIBFLASH_OBJS = libflash-file.o libflash-libflash.o libflash-libffs.o libflash-ecc.o libflash-blocklevel.o
ARCHFLASH_OBJS = common-arch_flash.o
OBJS = $(LIBFLASH_OBJS) $(ARCHFLASH_OBJS)

LIBFLASH_H = libflash/file.h libflash/libflash.h libflash/libffs.h libflash/ffs.h libflash/ecc.h libflash/blocklevel.h libflash/errors.h
ARCHFLASH_H = common/arch_flash.h

$(LIBFLASH_OBJS) : libflash-%.o : libflash/%.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -c $< -o $@

clean:
	rm -f $(OBJS) common-*.o *.so*

distclean: clean
	rm -f ccan libflash common

all: links arch_links $(OBJS)
	$(CC) -shared -Wl,-soname,libflash.so -o libflash.so.$(VERSION) $(OBJS)

install-lib: all
	install -D -m 0755 libflash.so.$(VERSION) $(LIBDIR)/libflash.so.$(VERSION)
	ln -sf libflash.so.$(VERSION) $(LIBDIR)/libflash.so

install-dev: links arch_links
	mkdir -p $(INCDIR)
	install -m 0644 $(LIBFLASH_H) $(ARCHFLASH_H) $(INCDIR)

install: install-lib install-dev

uninstall:
	rm -f $(LIBDIR)/libflash*
	rm -rf $(INCDIR)

=== debian/changelog ===
skiboot (5.2.2-2) unstable; urgency=medium

  * Fixed d/copyright 3 files

 -- Frederic Bonnard <frediz@linux.vnet.ibm.com>  Mon, 13 Jun 2016 11:49:19 +0200

skiboot (5.2.2-1) unstable; urgency=medium

  * Import from Ubuntu and update to upstream release  (Closes: #797987)

 -- Frederic Bonnard <frediz@linux.vnet.ibm.com>  Thu, 02 Jun 2016 15:34:47 +0200

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

UPSTREAM_VERSION := $(shell dpkg-parsechangelog -S Version | sed 's/-.*//')

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all


%:
	dh $@ --with systemd

override_dh_auto_build:
	OPAL_PRD_VERSION=opal-prd-$(UPSTREAM_VERSION) make V=1 -C external/opal-prd/
	GARD_VERSION=gard-$(UPSTREAM_VERSION) make V=1 -C external/gard/

override_dh_auto_install:
	make -C external/opal-prd/ prefix=/usr DESTDIR=../../debian/tmp/ install
	make -C external/gard/ prefix=/usr DESTDIR=../../debian/tmp/ install

override_dh_auto_clean:
	make -C external/opal-prd/ clean
	make -C external/gard/ clean
	rm -f external/opal-prd/ccan \
		external/opal-prd/.version \
		external/opal-prd/version.c \
		external/opal-prd/common \
		external/opal-prd/libflash \
		external/gard/version.c \
		external/gard/common \
		external/gard/ccan \
		external/gard/make_version.sh \
		external/gard/libflash
	dh_auto_clean

## skiboot 5.2.4

=== external/opal-prd/Makefile ===
--- 
+++ 
@@ -8,18 +8,10 @@
 datadir = $(prefix)/share
 mandir = $(datadir)/man
 
-all: opal-prd
+all: links arch_links | opal-prd
 
 GET_ARCH = ../../external/common/get_arch.sh
 include ../../external/common/rules.mk
-
-# Use make V=1 for a verbose build.
-ifndef V
-        Q_CC=	@echo '    CC ' $@;
-        Q_LINK=	@echo '  LINK ' $@;
-        Q_LN=   @echo '    LN ' $@;
-        Q_MKDIR=@echo ' MKDIR ' $@;
-endif
 
 LIBFLASH_OBJS = libflash-blocklevel.o libflash-libffs.o \
                 libflash-libflash.o libflash-ecc.o \
@@ -28,29 +20,16 @@
 OBJS = opal-prd.o thunk.o pnor.o i2c.o module.o version.o \
        $(LIBFLASH_OBJS) common-arch_flash.o
 
-LINKS = ccan common libflash $(ARCH_LINKS)
-
 OPAL_PRD_VERSION ?= $(shell ../../make_version.sh opal-prd)
 
 ifdef KERNEL_DIR
-LINKS += asm/opal-prd.h
+links += asm/opal-prd.h
 endif
-
-ccan:
-	$(Q_LN)ln -sfr ../../ccan ./ccan
-
-libflash:
-	$(Q_LN)ln -sfr ../../libflash ./libflash
-
-common:
-	$(Q_LN)ln -sfr ../common ./common
 
 asm/opal-prd.h:
 	$(Q_MKDIR)mkdir -p asm
 	$(Q_LN)ln -sfr $(KERNEL_DIR)/arch/powerpc/include/uapi/asm/opal-prd.h \
 			asm/opal-prd.h
-
-$(OBJS): | $(LINKS)
 
 %.o: %.c
 	$(Q_CC)$(COMPILE.c) $< -o $@
@@ -77,7 +56,7 @@
 	@cmp -s $@ $@.tmp || cp $@.tmp $@
 	@rm -f $@.tmp
 
-test: $(LINKS) test/test_pnor
+test: links test/test_pnor
 
 test/test_pnor: test/test_pnor.o pnor.o $(LIBFLASH_OBJS) common-arch_flash.o
 	$(Q_LINK)$(LINK.o) -o $@ $^

=== external/pflash/Makefile ===
include rules.mk
GET_ARCH = ../../external/common/get_arch.sh
include ../../external/common/rules.mk

all: links arch_links $(EXE)

.PHONY: VERSION-always
.version: VERSION-always
	@echo $(PFLASH_VERSION) > $@.tmp
	@cmp -s $@ $@.tmp || cp $@.tmp $@
	@rm -f $@.tmp

install: all $(INSTALLDEPS)
	install -D pflash $(DESTDIR)$(sbindir)/pflash

.PHONY: dist
#File is named $(PFLASH_VERSION).tar because the expectation is that pflash-
#is always at the start of the verion. This remains consistent with skiboot
#version strings
dist: links .version
	find -L ../pflash/ -iname '*.[ch]' -print0 | xargs -0 tar -rhf $(PFLASH_VERSION).tar
	tar --transform 's/Makefile.dist/Makefile/' -rhf $(PFLASH_VERSION).tar \
		../pflash/Makefile.dist ../pflash/rules.mk \
		../pflash/.version ../pflash/make_version.sh \
		../pflash/common/*

.PHONY: clean
clean: arch_clean
	rm -f $(OBJS) $(EXE) *.o *.d
.PHONY: distclean
distclean: clean
	rm -f *.c~ *.h~ *.sh~ Makefile~ config.mk~ libflash/*.c~ libflash/*.h~
	rm -f libflash ccan .version .version.tmp
	rm -f common io.h

=== external/shared/Makefile ===
.DEFAULT_GOAL := all
GET_ARCH = ../../external/common/get_arch.sh
include ../../external/common/rules.mk
include rules.mk

PREFIX ?= /usr/local/
LIBDIR = $(PREFIX)/lib
INCDIR = $(PREFIX)/include/libflash

ifneq ($(ARCH), ARCH_ARM)
CFLAGS += -m64
endif
CFLAGS += -Werror -Wall -g2 -ggdb -I. -fPIC

LIBFLASH_OBJS = libflash-file.o libflash-libflash.o libflash-libffs.o libflash-ecc.o libflash-blocklevel.o
ARCHFLASH_OBJS = common-arch_flash.o
OBJS = $(LIBFLASH_OBJS) $(ARCHFLASH_OBJS)

LIBFLASH_H = libflash/file.h libflash/libflash.h libflash/libffs.h libflash/ffs.h libflash/ecc.h libflash/blocklevel.h libflash/errors.h
ARCHFLASH_H = common/arch_flash.h

$(LIBFLASH_OBJS) : libflash-%.o : libflash/%.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -c $< -o $@

clean:
	rm -f $(OBJS) common-*.o *.so*

distclean: clean
	rm -f ccan libflash common

all: links arch_links $(OBJS)
	$(CC) -shared -Wl,-soname,libflash.so -o $(SHARED_NAME) $(OBJS)

install-lib: all
	install -D -m 0755 $(SHARED_NAME) $(LIBDIR)/$(SHARED_NAME)
	ln -sf $(SHARED_NAME) $(LIBDIR)/libflash.so

install-dev: links arch_links
	mkdir -p $(INCDIR)
	install -m 0644 $(LIBFLASH_H) $(ARCHFLASH_H) $(INCDIR)

install: install-lib install-dev

uninstall:
	rm -f $(LIBDIR)/libflash*
	rm -rf $(INCDIR)

=== debian/changelog ===
skiboot (5.2.4-1) unstable; urgency=medium

  * New upstream release
  * Disabled PIE build as this makes opal-prd segfault and there is no
    possibility to improve that on the code side soon.
  * Removed typos patch as it was partially applied in new version.

 -- Frederic Bonnard <frediz@linux.vnet.ibm.com>  Tue, 12 Jul 2016 17:54:46 +0200

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,9 @@
 Source: skiboot
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Jeremy Kerr <jk@ozlabs.org>
+Maintainer: Frederic Bonnard <frediz@linux.vnet.ibm.com>
 Build-Depends: debhelper (>= 9), dh-systemd
-Standards-Version: 3.9.5
+Standards-Version: 3.9.8
 Homepage: http://github.com/open-power/skiboot/
 #Vcs-Git: git://git.debian.org/collab-maint/skiboot.git
 #Vcs-Browser: http://git.debian.org/?p=collab-maint/skiboot.git;a=summary

=== debian/rules ===
--- 
+++ 
@@ -5,7 +5,8 @@
 
 # Uncomment this to turn on verbose mode.
 export DH_VERBOSE=1
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+# Disable PIE flag has it makes opal-prd segfault
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie
 
 
 %:

## skiboot 5.3.3

=== external/pflash/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 include rules.mk
-GET_ARCH = ../../external/common/get_arch.sh
+GET_ARCH := ../../external/common/get_arch.sh
 include ../../external/common/rules.mk
 
 all: links arch_links $(EXE)

=== external/shared/Makefile ===
.DEFAULT_GOAL := all
GET_ARCH := ../../external/common/get_arch.sh
include ../../external/common/rules.mk
include rules.mk

PREFIX ?= /usr/local/
LIBDIR := $(PREFIX)/lib
INCDIR := $(PREFIX)/include/libflash

ifneq ($(ARCH), ARCH_ARM)
CFLAGS += -m64
endif
CFLAGS += -Werror -Wall -g2 -ggdb -I. -fPIC

LIBFLASH_OBJS := libflash-file.o libflash-libflash.o libflash-libffs.o \
	libflash-ecc.o libflash-blocklevel.o
ARCHFLASH_OBJS := common-arch_flash.o
OBJS := $(LIBFLASH_OBJS) $(ARCHFLASH_OBJS)

LIBFLASH_H := libflash/file.h libflash/libflash.h libflash/libffs.h \
	libflash/ffs.h libflash/ecc.h libflash/blocklevel.h libflash/errors.h
ARCHFLASH_H := common/arch_flash.h

LIBFLASH_FILES := libflash.c libffs.c ecc.c blocklevel.c file.c
LIBFLASH_SRC := $(addprefix libflash/,$(LIBFLASH_FILES))

$(LIBFLASH_SRC): | links

$(LIBFLASH_OBJS) : libflash-%.o : libflash/%.c
	$(CC) $(CFLAGS) $(CPPFLAGS) -c $< -o $@

clean:
	rm -f $(OBJS) common-*.o *.so*

distclean: clean
	rm -f ccan libflash common

all: links arch_links $(OBJS)
	$(CC) -shared -Wl,-soname,libflash.so -o $(SHARED_NAME) $(OBJS)

install-lib: all
	install -D -m 0755 $(SHARED_NAME) $(LIBDIR)/$(SHARED_NAME)
	ln -sf $(SHARED_NAME) $(LIBDIR)/libflash.so

install-dev: links arch_links
	mkdir -p $(INCDIR)
	install -m 0644 $(LIBFLASH_H) $(ARCHFLASH_H) $(INCDIR)

install: install-lib install-dev

uninstall:
	rm -f $(LIBDIR)/libflash*
	rm -rf $(INCDIR)

=== debian/changelog ===
skiboot (5.3.3-1ubuntu0.1) yakkety; urgency=medium

  * debian/opal-prd.service: set Restart=always, which is the correct policy
    for this hardware-related service in the unlikely event of crashes.
    LP: #1671019.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 10 Jun 2017 13:06:37 -0700

skiboot (5.3.3-1) unstable; urgency=medium

  * New upstream release
  * Build and distribute getscom, putscom, pflash. Created basic manpages
    (Closes: #836405))
  * Changed d/opal-prd.docs, d/opal-utils.docs because README got renamed to
    README

 -- Frederic Bonnard <frediz@linux.vnet.ibm.com>  Tue, 06 Sep 2016 10:11:25 +0200

skiboot (5.2.4-2) unstable; urgency=medium

  * Forced no-pie for Ubuntu 16.10 as previous change was not enough : in 16.10
    gcc's default change to build PIE by default.

 -- Frederic Bonnard <frediz@linux.vnet.ibm.com>  Mon, 18 Jul 2016 15:52:41 +0200

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: skiboot
 Section: admin
 Priority: optional
-Maintainer: Frederic Bonnard <frediz@linux.vnet.ibm.com>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Frederic Bonnard <frediz@linux.vnet.ibm.com>
 Build-Depends: debhelper (>= 9), dh-systemd
 Standards-Version: 3.9.8
 Homepage: http://github.com/open-power/skiboot/

## skiboot 5.4.3

=== Makefile ===
--- 
+++ 
@@ -16,6 +16,11 @@
 endif
 
 #
+# Main debug switch
+#
+DEBUG ?= 0
+
+#
 # Set to enable SLW bits
 #
 PORE ?= 1
@@ -30,7 +35,7 @@
 #
 # Optional build with advanced stack checking
 #
-STACK_CHECK ?= 0
+STACK_CHECK ?= $(DEBUG)
 
 #
 # Where is the source directory, must be a full path (no ~)

=== external/opal-prd/Makefile ===
--- 
+++ 
@@ -71,3 +71,4 @@
 
 distclean: clean
 	$(RM) -f $(LINKS) asm
+	$(RM) -f libflash ccan version.c .version common

=== external/xscom-utils/Makefile ===
CC = $(CROSS_COMPILE)gcc

XSCOM_VERSION ?= $(shell ../../make_version.sh xscom-utils)
CFLAGS += -O2 -g -Wall -m64

prefix = /usr/local/
sbindir = $(prefix)/sbin
datadir = $(prefix)/share
mandir = $(datadir)/man

%.o: %.c
	$(Q_CC)$(COMPILE.c) $< -o $@

# Use make V=1 for a verbose build.
ifndef V
        Q_CC=	@echo '    CC ' $@;
        Q_LINK=	@echo '  LINK ' $@;
        Q_LN=   @echo '    LN ' $@;
        Q_MKDIR=@echo ' MKDIR ' $@;
endif

all: getscom putscom getsram

getscom: getscom.c xscom.o version.o
	$(Q_LINK)$(LINK.o) -o $@ $^

getsram: getsram.o xscom.o sram.o version.o
	$(Q_LINK)$(LINK.o) -o $@ $^

putscom: putscom.o xscom.o version.o
	$(Q_LINK)$(LINK.o) -o $@ $^

install: all
	install -D getscom $(DESTDIR)$(sbindir)/getscom
	install -D putscom $(DESTDIR)$(sbindir)/putscom
	install -D getsram $(DESTDIR)$(sbindir)/getsram

.PHONY: clean
clean:
	rm -rf *.[od] getscom putscom getsram

.PHONY: distclean
distclean: clean
	rm -rf *.c~ *.h~ *.i *.s Makefile~

version.c: ../../make_version.sh  .version
	@(if [ "a$(XSCOM_VERSION)" = "a" ]; then \
	echo "#error You need to set XSCOM_VERSION environment variable" > $@ ;\
	else \
	echo "const char version[] = \"$(XSCOM_VERSION)\";" ;\
	fi) > $@

.PHONY: VERSION-always
.version: VERSION-always
	@echo $(XSCOM_VERSION) > $@.tmp
	@cmp -s $@ $@.tmp || cp $@.tmp $@
	@rm -f $@.tmp

=== debian/changelog ===
skiboot (5.4.3-1ubuntu0.16.04.2) xenial; urgency=medium

  * opal-prd: Have a worker process handle page offlining
     (LP: #1904585) Have a worker process handle page offlining
     d/patches/fix-opal-prd-have-worker-process-handle-page-offlining.patch

 -- Matthieu Clemenceau <matthieu.clemenceau@canonical.com>  Fri, 11 Dec 2020 14:22:13 -0600

skiboot (5.4.3-1ubuntu0.16.04.1) xenial; urgency=medium

  * Backport latest upstream release to xenial. (LP: #1701698)
  * Merge the xenial and Debian changelogs.

 -- Łukasz 'sil2100' Zemczak <lukasz.zemczak@ubuntu.com>  Tue, 11 Jul 2017 14:42:14 +0200

skiboot (5.4.3-1) unstable; urgency=medium

  * New upstream release
  * d/patches/fix-hardening-for-opal-gard.patch removed as it's applied upstream
  * d/control : 
    - added Depends on lsb-base for opal-prd.init
    - added ppc64 arch
  * d/rules :
    - proper clean is almost done by upstream, override_dh_auto_clean stripped
    - enabled tests where they make sense
  * d/patches/fix-distclean-for-gard-and-xscom-utils.patch : remaining cleanup
    to be forwarded upstream
  * d/opal-prd.socket : removed
    d/opal-prd.service : linked to upstream service file
    we now use service file from upstream that doesn't use systemd's socket
    : opal-prd already does all the socket handling.
  * d/patches/opal-prd-service-file-improvements.patch : added to handle man
    page and /etc/default/opal-prd properly (Closes: LP : #1549098)
  * Use upstream manpage :
    d/opal-prd.8 : fixes were applied upstream
    d/opal-prd.manpages : use upstream manpage 
  * d/patches/direct-systemd-to-always-restart-opal-prd.patch : applying
    upstream patch in advance to restart opal-prd irrespective of why it
    stopped.  (Closes: LP : #1671019)

 -- Frederic Bonnard <frediz@linux.vnet.ibm.com>  Wed, 08 Mar 2017 16:06:12 +0000

skiboot (5.1.13-0ubuntu3) xenial; urgency=medium

  * debian/opal-prd.service: set Restart=always, which is the correct policy
    for this hardware-related service in the unlikely event of crashes.
    LP: #1671019.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 10 Jun 2017 21:34:52 -0700

skiboot (5.1.13-0ubuntu2) xenial; urgency=medium

  * Update debian/opal-prd.service so that the command for systemd matches
    the one for upstart.  Thanks to Cédric Le Goater <clg@fr.ibm.com>
    for the fix.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 05 Feb 2016 10:21:00 -0800

skiboot (5.1.13-0ubuntu1) xenial; urgency=medium

  * New upstream release, adding support for newer hardware and firmware.
    LP: #1512188.
    - drop no longer needed parts of debian/patches/uninitialized_uses.patch.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 04 Feb 2016 11:05:13 -0800

skiboot (5.1.1-0ubuntu1) wily; urgency=medium

  * New upstream release.
  * Dropped patches; applied upstream:
    - 0001-external-gard-add-Makefile-targets-to-make-debian-pa.patch
    - 0001-Honor-compilation-flags-passed-from-the-environment.patch
    - 0001-Fixes-for-compilation-with-Werror.patch
  * debian/patches/uninitialized_uses.patch: fix up uninitialized variables
    that make our build fail.

 -- Mathieu Trudel-Lapierre <mathieu-tl@ubuntu.com>  Tue, 01 Sep 2015 12:36:25 -0400

=== debian/control ===
Source: skiboot
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Frederic Bonnard <frediz@linux.vnet.ibm.com>
Build-Depends: debhelper (>= 9), dh-systemd
Standards-Version: 3.9.8
Homepage: http://github.com/open-power/skiboot/

Package: opal-prd
Architecture: ppc64el ppc64
Depends: ${misc:Depends}, ${shlibs:Depends}, lsb-base
Description: OPAL Processor Recovery Diagnostics daemon
 This package provides a daemon to load and run the OpenPower firmware's
 Processor Recovery Diagnostics binary. This is responsible for runtime
 maintenance of Power hardware.

Package: opal-utils
Architecture: ppc64el ppc64
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: OPAL firmware utilities
 This package contains utility programs.
 .
 The 'gard' utility, can read, parse and clear hardware gard partitions on
 OpenPower platforms.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

UPSTREAM_VERSION := $(shell dpkg-parsechangelog -S Version | sed 's/-.*//')

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# Disable PIE flag has it makes opal-prd segfault
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie
# Also force no-pie for Ubuntu 16.10 where gcc's defaults have been set to
# build Position Independent Executables (PIE) on amd64 and ppc64le (gcc was
# configured this way for s390x in Ubuntu 16.04 LTS).
export DEB_LDFLAGS_MAINT_APPEND = -no-pie


%:
	dh $@ --with systemd

override_dh_auto_build:
	OPAL_PRD_VERSION=opal-prd-$(UPSTREAM_VERSION) make V=1 -C external/opal-prd/
	GARD_VERSION=gard-$(UPSTREAM_VERSION) make V=1 -C external/gard/
	PFLASH_VERSION=pflash-$(UPSTREAM_VERSION) make V=1 -C external/pflash
	XSCOM_VERSION=xcom-$(UPSTREAM_VERSION) make V=1 -C external/xscom-utils

override_dh_auto_install:
	make -C external/opal-prd/ prefix=/usr DESTDIR=../../debian/tmp/ install
	make -C external/gard/ prefix=/usr DESTDIR=../../debian/tmp/ install
	make -C external/pflash/ prefix=/usr DESTDIR=../../debian/tmp/ install
	make -C external/xscom-utils/ prefix=/usr DESTDIR=../../debian/tmp/ install

override_dh_auto_clean:
	make -C external/opal-prd/ distclean
	make -C external/gard/ distclean
	make -C external/pflash/ distclean
	make -C external/xscom-utils/ distclean
	dh_auto_clean

override_dh_auto_test:
	# We only run test for the directories we build utils from and where tests exists
	make -C external/gard/ check

## skiboot 5.10~rc4

=== Makefile ===
--- 
+++ 
@@ -20,10 +20,8 @@
 #
 DEBUG ?= 0
 
-#
-# Set to enable SLW bits
-#
-PORE ?= 1
+# Run tests under valgrind?
+USE_VALGRIND ?= 1
 
 #
 # Optional location of embedded linux kernel file
@@ -36,6 +34,16 @@
 # Optional build with advanced stack checking
 #
 STACK_CHECK ?= $(DEBUG)
+
+#
+# Experimental (unsupported) build options
+#
+# Little-endian does not yet build. Include it here to set ELF ABI.
+LITTLE_ENDIAN ?= 0
+# ELF v2 ABI is more efficient and compact
+ELF_ABI_v2 ?= $(LITTLE_ENDIAN)
+# Discard unreferenced code and data at link-time
+DEAD_CODE_ELIMINATION ?= 0
 
 #
 # Where is the source directory, must be a full path (no ~)

=== debian/changelog ===
skiboot (5.10~rc4-1ubuntu1) bionic; urgency=medium

  * debian/patches/0001-opal-prd-Insert-powernv_flash-module.patch:
    cherry-pick from upstream to fix opal-prd spinning and consuming 100%
    CPU if it starts on boot before the mtd module has been loaded.
    LP: #1765460.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 23 Apr 2018 09:50:43 -0700

skiboot (5.10~rc4-1) unstable; urgency=medium

  * New upstream version 5.10~rc4 (Closes: LP: #1744710)
  * Improve watch file
  * Add gbp configuration locally
  * Rediff patches
  * Update maintainer information
  * Use https instead of https where available
  * Add Vcs-* URI on salsa.debian.org
  * Remove default PNOR device since autodetected now
  * Remove upstart support
  * Install man pages from the source
  * Add getsram utility in the package (Closes: #874386)
  * Avoid running tests on unsupported platforms
  * Make use of Debian provided DEB_VERSION_UPSTREAM
  * Improve logging support
  * Bump Standards-Version (upstart support dropped)
  * Bump compatibility level to 11 (dh systemd addon removed)

 -- Frédéric Bonnard <frediz@debian.org>  Thu, 22 Feb 2018 16:09:32 +0100

=== debian/control ===
--- 
+++ 
@@ -2,14 +2,17 @@
 Section: admin
 Priority: optional
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Frederic Bonnard <frediz@linux.vnet.ibm.com>
-Build-Depends: debhelper (>= 9), dh-systemd
-Standards-Version: 3.9.8
-Homepage: http://github.com/open-power/skiboot/
+XSBC-Original-Maintainer: Frédéric Bonnard <frediz@debian.org>
+Build-Depends: debhelper (>= 11)
+Standards-Version: 4.1.3
+Homepage: https://github.com/open-power/skiboot/
+Vcs-Git: https://salsa.debian.org/debian/skiboot.git                                
+Vcs-Browser: https://salsa.debian.org/debian/skiboot                                
 
 Package: opal-prd
 Architecture: ppc64el ppc64
 Depends: ${misc:Depends}, ${shlibs:Depends}, lsb-base
+Suggests: rsyslog
 Description: OPAL Processor Recovery Diagnostics daemon
  This package provides a daemon to load and run the OpenPower firmware's
  Processor Recovery Diagnostics binary. This is responsible for runtime

## skiboot 6.1

=== debian/changelog ===
skiboot (6.1-4) unstable; urgency=medium

  * Use file operation used on x86 for ARCH_UNKNOWN

 -- Frédéric Bonnard <frediz@debian.org>  Thu, 22 Nov 2018 16:26:10 +0100

skiboot (6.1-3) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/changelog: Remove trailing whitespaces

  [ Frédéric Bonnard ]
  * Use default m32 or m64 gcc flag for xscom-utils
  * Build opal-utils on any architecture
  * Define new package qemu-skiboot to provide skiboot firmware
  * Bump Standards-Version (no change needed)

 -- Frédéric Bonnard <frediz@debian.org>  Fri, 16 Nov 2018 11:11:55 +0100

skiboot (6.1-2) unstable; urgency=medium

  * Fix wrong owner after log is being rotated (Closes: LP: #1785026)

 -- Frédéric Bonnard <frediz@debian.org>  Thu, 02 Aug 2018 11:33:25 +0200

skiboot (6.1-1) unstable; urgency=medium

  * New upstream release
  * Improve formatting with wrap-and-sort
  * Set proper debhelper Build-Depends
  * Bump Standards-Version

 -- Frédéric Bonnard <frediz@debian.org>  Mon, 30 Jul 2018 11:31:54 +0200

skiboot (5.10~rc4-2) unstable; urgency=medium

  * Fix opal-prd spinning and consuming 100% CPU

 -- Frédéric Bonnard <frediz@debian.org>  Tue, 24 Apr 2018 13:12:19 +0200

=== debian/control ===
Source: skiboot
Section: admin
Priority: optional
Maintainer: Frédéric Bonnard <frediz@debian.org>
Build-Depends: debhelper (>= 11~)
Build-Depends-Indep: gcc-powerpc64-linux-gnu
Standards-Version: 4.2.1
Homepage: https://github.com/open-power/skiboot/
Vcs-Git: https://salsa.debian.org/debian/skiboot.git
Vcs-Browser: https://salsa.debian.org/debian/skiboot

Package: qemu-skiboot
Depends: ${misc:Depends}
Suggests: qemu
Architecture: all
Description: OpenPower firmware component
 This package provides the upstream skiboot binary suitable for using with the
 powernv Qemu machine.
 .
 It is not recommended to flash this binary as your system firmware.

Package: opal-prd
Architecture: ppc64 ppc64el
Depends: lsb-base, ${misc:Depends}, ${shlibs:Depends}
Suggests: rsyslog
Description: OPAL Processor Recovery Diagnostics daemon
 This package provides a daemon to load and run the OpenPower firmware's
 Processor Recovery Diagnostics binary. This is responsible for runtime
 maintenance of Power hardware.

Package: opal-utils
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: OPAL firmware utilities
 This package contains utility programs.
 .
 The 'gard' utility, can read, parse and clear hardware gard partitions on
 OpenPower platforms.

## skiboot 6.2

=== external/pflash/Makefile ===
--- 
+++ 
@@ -3,6 +3,14 @@
 include ../../external/common/rules.mk
 
 all: links arch_links $(EXE)
+
+#Rebuild version.o so that the the version always matches
+#what the test suite will get from ./make_version.sh
+check: version.o all
+	$(MAKE) -C ../ffspart
+	@ln -sf ../../make_version.sh make_version.sh
+	@ln -sf ../../test/test.sh test/test.sh
+	@test/test-pflash
 
 .PHONY: VERSION-always
 .version: VERSION-always
@@ -12,6 +20,7 @@
 
 install: all $(INSTALLDEPS)
 	install -D pflash $(DESTDIR)$(sbindir)/pflash
+	install -D -m 0644 pflash.1 $(DESTDIR)$(mandir)/man1/pflash.1
 
 .PHONY: dist
 #File is named $(PFLASH_VERSION).tar because the expectation is that pflash-
@@ -30,5 +39,5 @@
 .PHONY: distclean
 distclean: clean
 	rm -f *.c~ *.h~ *.sh~ Makefile~ config.mk~ libflash/*.c~ libflash/*.h~
-	rm -f libflash ccan .version .version.tmp
+	rm -f libflash ccan version.c .version .version.tmp
 	rm -f common io.h

=== debian/changelog ===
skiboot (6.2-1) unstable; urgency=medium

  * New upstream release 6.2
  * Upgrade compat level
  * Add Multi-Arch hinter
  * Bump Standards-Version

 -- Frédéric Bonnard <frediz@debian.org>  Fri, 11 Jan 2019 13:57:30 +0100

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: admin
 Priority: optional
 Maintainer: Frédéric Bonnard <frediz@debian.org>
-Build-Depends: debhelper (>= 11~)
+Build-Depends: debhelper (>= 12~)
 Build-Depends-Indep: gcc-powerpc64-linux-gnu
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Homepage: https://github.com/open-power/skiboot/
 Vcs-Git: https://salsa.debian.org/debian/skiboot.git
 Vcs-Browser: https://salsa.debian.org/debian/skiboot
@@ -13,6 +13,7 @@
 Depends: ${misc:Depends}
 Suggests: qemu
 Architecture: all
+Multi-Arch: foreign
 Description: OpenPower firmware component
  This package provides the upstream skiboot binary suitable for using with the
  powernv Qemu machine.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# Disable PIE flag has it makes opal-prd segfault
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie
# Also force no-pie for Ubuntu 16.10 where gcc's defaults have been set to
# build Position Independent Executables (PIE) on amd64 and ppc64le (gcc was
# configured this way for s390x in Ubuntu 16.04 LTS).
export DEB_LDFLAGS_MAINT_APPEND = -no-pie


%:
	dh $@

override_dh_auto_build-indep:
	SKIBOOT_VERSION=skiboot-$(DEB_VERSION_UPSTREAM) CROSS=powerpc64-linux-gnu- make skiboot.lid V=1

override_dh_auto_build-arch:
ifneq (,$(filter $(DEB_TARGET_ARCH), ppc64 ppc64el))
	OPAL_PRD_VERSION=opal-prd-$(DEB_VERSION_UPSTREAM) make V=1 -C external/opal-prd/
endif
	GARD_VERSION=gard-$(DEB_VERSION_UPSTREAM) make V=1 -C external/gard/
	PFLASH_VERSION=pflash-$(DEB_VERSION_UPSTREAM) make V=1 -C external/pflash
	XSCOM_VERSION=xcom-$(DEB_VERSION_UPSTREAM) make V=1 -C external/xscom-utils

override_dh_auto_install-indep:
	install -D -m 0644 skiboot.lid $(CURDIR)/debian/tmp/usr/share/skiboot/skiboot.lid

override_dh_auto_install-arch:
ifneq (,$(filter $(DEB_TARGET_ARCH), ppc64 ppc64el))
	make -C external/opal-prd/ prefix=/usr DESTDIR=../../debian/tmp/ install
endif
	make -C external/gard/ prefix=/usr DESTDIR=../../debian/tmp/ install
	make -C external/pflash/ prefix=/usr DESTDIR=../../debian/tmp/ install
	make -C external/xscom-utils/ prefix=/usr DESTDIR=../../debian/tmp/ install

override_dh_auto_clean:
	make -C external/opal-prd/ distclean
	make -C external/gard/ distclean
	make -C external/pflash/ distclean
	make -C external/xscom-utils/ distclean
	dh_auto_clean

override_dh_auto_test-indep:
	# At the moment no easy/possible check target test/Makefile.check

override_dh_auto_test-arch:
	# We only run test for the directories we build utils from and where tests exists
	# gard tests : no support for FSP based build systems
	[ -d /proc/device-tree/fsps ] || make -C external/gard/ check

## skiboot 6.5

=== debian/changelog ===
skiboot (6.5-1) unstable; urgency=medium

  * Update to new upstream version 6.5.
  * Upgrade debhelper compatibility version
  * Fix lintian skip-systemd-native-flag-missing-pre-depends
  * Bump Standards-Version (no change needed)
  * Update d/copyright information
  * Move sbin commands manpages from section 1 to 8

 -- Frédéric Bonnard <frediz@debian.org>  Wed, 21 Aug 2019 15:15:46 +0200

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: admin
 Priority: optional
 Maintainer: Frédéric Bonnard <frediz@debian.org>
-Build-Depends: debhelper (>= 12~)
+Build-Depends: debhelper-compat (= 12)
 Build-Depends-Indep: gcc-powerpc64-linux-gnu
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Homepage: https://github.com/open-power/skiboot/
 Vcs-Git: https://salsa.debian.org/debian/skiboot.git
 Vcs-Browser: https://salsa.debian.org/debian/skiboot
@@ -23,6 +23,7 @@
 Package: opal-prd
 Architecture: ppc64 ppc64el
 Depends: lsb-base, ${misc:Depends}, ${shlibs:Depends}
+Pre-Depends: ${misc:Pre-Depends}
 Suggests: rsyslog
 Description: OPAL Processor Recovery Diagnostics daemon
  This package provides a daemon to load and run the OpenPower firmware's
